{$DEFINE Backwards} // Backwards Compatibility - when this is defined, this version (2.01) is compatible with 2.00 and 1.00
                    // 1.00 defined Transparent:Boolean, 2.00 defined Faded:Boolean, and 2.01 got rid of them both.
                    // Except that I did actually leave them in, and this switch controls whether to compile that code or not.

//{$DEFINE DEBUG}

{ Version 2.01
  Modified exxieh@bath.ac.uk <Ian Hickson>
  Now fades bitmap, by default, to clBtnHighlight
  Defaults to alClient alignment

//----------------------------------------------------------------------//

             Copyright (C) 1996 Word in Action.  All Rights Reserved.
             Copyright    1996 by Ian Hickson.

    Project : Tile Component
    Company : Word in Action
    Files   : wiaTile.pas, wiaTile.dcr, readme.txt, demo\*.*
    Overview: This file is a control that allows an image to be tiled and
              is released into the public domain for your own useage although
              Word in Action and Ian Hickson retain the Copyright.

    Authors : Jay Giganti, Ian Hickson
    EMail   : Jay Giganti -- CompuServe ID: [72037,2225]
              Ian Hickson -- exxieh@bath.ac.uk

    72037.2225@compuserve.com -- http://ourworld.compuserve.com/homepages/jrg
    wordinaction@hypercon.com -- http://www.hypercon.com/wordinaction/
                  Ian Hickson -- http://www.bath.ac.uk/~exxieh 

          Please inform us of any comments, suggestions or improvements:
       *** Now for the stuff that we have unfortunately been driven to ***

    RIGHTS:     Title, ownership rights, and intellectual property rights in
                and to the Software shall remain in Word in Action and/or
                its suppliers. The Software is protected by the copyright
                laws of the United States and international copyright
                treaties. This License gives you no rights to such content.

    DISCLAIMER: This code is for demonstration purposes only and should
                be used at your own risk. Since the Software is provided free
                of charge, the Software is provided on an "AS IS" basis,
                without warranty of any kind, including without limitation
                the warranties of merchantability, fitness for a particular
                purpose and non-infringement. The entire risk as to the
                quality and performance of the Software is borne by you.
                Should the Software prove defective, you and not Word in Action
                assume the entire cost of any service and repair. In
                addition, you must determine that the Software sufficiently
                meets your requirements.  This disclaimer of warranty
                constitutes an essential part of the agreement. SOME STATES
                DO NOT ALLOW EXCLUSIONS OF AN IMPLIED WARRANTY, SO THIS
                DISCLAIMER MAY NOT APPLY TO YOU AND YOU MAY HAVE OTHER LEGAL
                RIGHTS THAT VARY FROM STATE TO STATE OR BY JURISDICTION.

    LIMITATIONS: LIABILITY -- UNDER NO CIRCUMSTANCES AND UNDER NO
                 LEGAL THEORY, TORT, CONTRACT, OR OTHERWISE, SHALL
                 Word in Action OR ITS SUPPLIERS OR RESELLERS BE LIABLE TO
                 YOU OR ANY OTHER PERSON FOR ANY INDIRECT, SPECIAL,
                 INCIDENTAL, OR CONSEQUENTIAL DAMAGES OF ANY CHARACTER
                 INCLUDING, WITHOUT LIMITATION, DAMAGES FOR LOSS OF GOODWILL,
                 WORK STOPPAGE, COMPUTER FAILURE OR MALFUNCTION, OR ANY AND
                 ALL OTHER COMMERCIAL DAMAGES OR LOSSES. IN NO EVENT WILL Word
                 in Action BE LIABLE FOR ANY DAMAGES IN EXCESS OF Word in
                 Action's LIST PRICE FOR A LICENSE TO THE SOFTWARE, EVEN IF
                 Word in Action SHALL HAVE BEEN INFORMED OF THE POSSIBILITY
                 OF SUCH DAMAGES, OR FOR ANY CLAIM BY ANY OTHER PARTY. THIS
                 LIMITATION OF LIABILITY SHALL NOT APPLY TO LIABILITY FOR
                 DEATH OR PERSONAL INJURY TO THE EXTENT APPLICABLE LAW
                 PROHIBITS SUCH LIMITATION. FURTHERMORE, SOME STATES DO NOT
                 ALLOW THE EXCLUSION OR LIMITATION OF INCIDENTAL OR
                 CONSEQUENTIAL DAMAGES, SO THIS LIMITATION AND EXCLUSION MAY
                 NOT APPLY TO YOU.

//----------------------------------------------------------------------//

    Please note that I (Ian Hickson) am not related to Word in Action.
    But I also decline all responsability.

//----------------------------------------------------------------------//

                     Version Information [month/day]
      Date    Ver  Comments
    ======== ===== ===========================================================
    01/26/96  1.00 Created this component
    12/01/96  2.00 modificatios by Ian Hickson
    12/07/96  2.01 bug fix for 2.00 (do I feel stupid or what)              }

    
{$A+,B-,F-,G+,I+,K+,N+,P+,T+,V+,W-,X+}
{$IFNDEF DEBUG}
{$D-,L-,Q-,R-,S-,Y-}
{$ELSE}
{$D+,L+,Q+,R+,S+,Y+}
{$ENDIF}

unit wiaTile;

interface
uses             // WinTypes/WinProcs changed to Windows by Ian Hickson <exxieh@bath.ac.uk> 7/9/96
  SysUtils, Windows, Messages, Classes, Graphics, Controls;

type
  TwiaTileMode = (tmFaded, tmTransparent, tmNormal);
  TwiaTile = class(TGraphicControl)
  protected
    FImage           : TBitmap;
    FInternalImage   : TBitmap;
//    FTransparent     : Boolean;   // 2.00
//    FFaded           : Boolean;
    FMode            : TwiatileMode; // 2.01
    FTranColor       : TColor;
    FFadeColor       : TColor; 

    TrnBmp           : TBitmap;

    procedure ChangedImage(Sender: TObject);
    function  GetPalette: HPALETTE; override;
    procedure Paint; override;
    procedure SetImage(Value: TBitMap);
    {$IFDEF Backwards}
    procedure SetTran(Value: Boolean);
    procedure SetFade(Value: Boolean);
    function GetTran: Boolean;
    function GetFade: Boolean;
    {$ENDIF}
    procedure SetMode(Value: TwiaTileMode);
    procedure SetTranColor(Value: TColor);
    procedure SetFadeColor(Value: TColor);

  public
    constructor Create(AOwner: TComponent); override;
    destructor  Destroy; override;

  published
    property Image    : TBitMap read FInternalImage write SetImage;
//    property ImageTrn : TBitMap read TrnBmp stored False; // for debug
//    property ImageIma : TBitMap read FImage stored False; // for debug
    property TranColor: TColor read FTranColor write SetTranColor nodefault;
    property FadeColor: TColor read FFadeColor write SetFadeColor default clBtnHighlight;
    {$IFDEF Backwards}
    property Transparent:Boolean read GetTran write SetTran stored False; // Left in for Backwards Compability
    property Faded:Boolean read GetFade write SetFade stored False; // Left in for Backwards Compability
    {$ENDIF}
    property TileMode : TwiaTileMode read FMode write SetMode default tmFaded;

    property Height default 64;
    property Width  default 64;
    property Visible;
    property Align default alClient;
    property Enabled;
    property ParentShowHint;
    property ShowHint;
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
  end;

  procedure Register;

implementation
{$IFDEF Backwards} uses Dialogs; {$ENDIF}

procedure Register;
begin
  RegisterComponents('Graphics', [TwiaTile]);
end;

{==============================================================================
                                 Create
Purpose: To Initialize the Object
Details: Let the base class get a creack at initialization and then set up the
         default values and create the bitmap place holders.
==============================================================================}
constructor TwiaTile.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FInternalImage          := TBitMap.Create;
  FImage          := TBitMap.Create;
  TrnBmp          := TBitMap.Create;
  FInternalImage.OnChange := ChangedImage;
  FFadeColor      := clBtnHighlight;
//  FTransparent    := True; // 2.00
//  FFaded          := True;
  FMode := tmFaded; // 2.01
  SetBounds(0, 0, 64, 64);
  Align := alClient;
end;
{==============================================================================
                                 Destroy
Purpose: To Free any memory associated with this object
==============================================================================}
destructor TwiaTile.Destroy;
begin
  FImage.Free;
  TrnBmp.Free;
  FInternalImage.Free;
  inherited Destroy;
end;
{==============================================================================
                                 ChangedImage
==============================================================================}
// 2.00 -> 2.01 conversion changed some logic. Changes not commented.
procedure TwiaTile.ChangedImage(Sender: TObject);
var
 clrOld: TColor;
begin
  FImage.Assign(FInternalImage); // update images
  TrnBmp.Assign(FInternalImage);
  clrOld := GetBkColor(FImage.Canvas.Handle);
  TrnBmp.Width      := FImage.Width;
  TrnBmp.Height     := FImage.Height;
  TrnBmp.MonoChrome := True;

  if (FMode <> tmNormal) then
  begin
     SetBkColor(FImage.Canvas.Handle, FTranColor);
     BitBlt(TrnBmp.Canvas.Handle, 0, 0, FImage.Width, FImage.Height,
            FImage.Canvas.Handle, 0, 0, SRCCOPY);

     If FMode = tmFaded then // now that the TRnBmp is bicolour...
     begin
        FImage.Monochrome := False;
        TrnBmp.Monochrome := False;
        FImage.Assign(TrnBmp);
        FImage.Canvas.Brush.Color := FFadeColor;
        FImage.Canvas.BrushCopy(Rect (0, 0, TrnBmp.Width, TRnBmp.Height), TrnBmp, Rect (0, 0, TrnBmp.Width, TRnBmp.Height), clBlack);
//        FImage.Canvas.Brush.Color := clBlack;
        FImage.Canvas.Brush.Color := (Parent as TWinControl).Brush.Color;
        FImage.Canvas.BrushCopy(Rect (0, 0, FImage.Width, FImage.Height), FImage, Rect (0, 0, FImage.Width, FImage.Height), clWhite);
{ // old systems
        TrnBmp.MonoChrome := False; // no longer!
        SetBkColor(TrnBmp.Canvas.Handle, clWhite); // (Parent as TWinControl).Brush.Color
        TrnBmp.Canvas.Brush.Color := (Parent as TWinControl).Brush.Color;
        TrnBmp.Canvas.BrushCopy(Rect (0, 0, TrnBmp.Width, TRnBmp.Height), TrnBmp, Rect (0, 0, TrnBmp.Width, TRnBmp.Height), clWhite);
        SetBkColor(FImage.Canvas.Handle, clWhite);
        SetTextColor(FImage.Canvas.Handle, FFadeColor);
        BitBlt(FImage.Canvas.Handle, 0, 0, FImage.Width, FImage.Height,
               TrnBmp.Canvas.Handle, 0, 0, SRCCOPY);
 // }
     end
     else
     begin
        SetBkColor(FImage.Canvas.Handle, clBlack);
        SetTextColor(FImage.Canvas.Handle, clWhite);
        BitBlt(FImage.Canvas.Handle, 0, 0, FImage.Width, FImage.Height, // Only the black areas are written to - white on mask is
               TrnBmp.Canvas.Handle, 0, 0, SRCAND);                     // left as BkColor
        SetBkColor(FImage.Canvas.Handle, clrOld);
     end;
  end;
  Invalidate;
end;
{==============================================================================
                                 GetPalette
==============================================================================}
// 2.00 -> 2.01 conversion changed some logic. Changes not commented.
function TwiaTile.GetPalette: HPALETTE;
begin
  if (FImage.Height > 0)  AND (FImage.Width > 0) then
  begin
     Case FMode of
      tmFaded: Result := TrnBmp.Palette;
      tmTransparent: Result := FImage.Palette;
     else
        Result := FInternalImage.Palette;
     end;
  end
  else
     Result := 0;
end;
{==============================================================================
                                 Paint
==============================================================================}
// 2.00 -> 2.01 conversion changed some logic. Changes not commented.
procedure TwiaTile.Paint;
var
  X, Y, W, H: LongInt;
begin
  if (FImage.Height > 0) AND (FImage.Width > 0) then
  begin
    W     := FImage.Width;
    H     := FImage.Height;
    Y     := 0;
    while Y < Height do
    begin
      X := 0;
      while X < Width do
      begin
        Case FMode of
         tmNormal: Canvas.Draw(X, Y, FInternalImage);
         tmFaded: Canvas.Draw(X, Y, FImage);
        else
           begin
              BitBlt(Canvas.Handle, X, Y, W, H,
                     TrnBmp.Canvas.Handle, 0, 0, SRCAND);
              BitBlt(Canvas.Handle, X, Y, W, H,
                     FImage.Canvas.Handle, 0, 0, SRCPAINT);
           end;
        end;
        Inc(X, W);
      end;
      Inc(Y, H);
    end;
  end
  else if (csDesigning in ComponentState) then
  begin
    Canvas.Brush.Color := clGray;
    Canvas.FillRect(Rect(0, 0, Width, Height));
  end;
end;
{==============================================================================
                                 SetImage
==============================================================================}
procedure TwiaTile.SetImage(Value: TBitMap);
begin
  if Assigned(Value) then
  begin
    FTranColor := Value.TransparentColor;
    FInternalImage.Assign(Value); // calls ChangedImage through an Event (see constructor)
  end
  else
  begin
    FImage.Height := 0;
    FImage.Width  := 0;
  end;
end;
{==============================================================================
                              Property Handlers
==============================================================================}

{$IFDEF Backwards}

const
   WarnCount : Integer = 0;

procedure Warn (Self:TwiaTile);
begin
   If (csDesigning in Self.ComponentState) and not (csLoading in Self.ComponentState) and (WarnCount < 3) then
   begin
      Inc (WarnCount);
      MessageBeep (MB_IconWarning);
      MessageDlg ('It is recommended that you use the TileMode property instead of the Transparent/Faded combination.', mtWarning, [mbOk], 0);
   end;
   // This is a seriously twisted way of supporting backwards compatability, I know. - ieh.
end;

procedure TwiaTile.SetTran(Value: Boolean);
begin
   If Value then
      SetMode (tmTransparent)
   else
      SetMode (tmNormal);
   Warn(Self);
end;

procedure TwiaTile.SetFade(Value: Boolean);
begin
   If Value then
      SetMode (tmFaded)
   else
   If FMode = tmFaded then
      SetMode (tmTransparent);
   Warn(Self);
end;

function TwiaTile.GetTran: Boolean;
begin
   Result := FMode = tmTransparent;
end;

function TwiaTile.GetFade: Boolean;
begin
   Result := FMode = tmFaded;
end;

{$ENDIF}

procedure TwiaTile.SetMode(Value: twiaTileMode);
begin
  if FMode <> Value then
  begin
    FMode := Value;
    ChangedImage(Self);
  end;
end;

procedure TwiaTile.SetTranColor(Value: TColor);
begin
//  if FTranColor <> Value then
  begin
    FTranColor := Value;
    ChangedImage(Self);
  end;
end;

procedure TwiaTile.SetFadeColor(Value: TColor);
begin
//  if FFadeColor <> Value then
  begin
    FFadeColor := Value;
    ChangedImage(Self);
  end;
end;


// What with all these comments and stuff this code is getting somewhat messy, isn'it it...?  :=)

end.
